#include <iostream>
#include <algorithm>
#include <vector>
using namespace std ;
typedef long long ll ;
const ll INFTY = 1LL << 60 ;
vector<ll> ta, tb ;
vector<int> ca, cb ;
vector<vector<int> > perc ;
vector<ll> minf ;
int main() {
   int n, m ;
   cin >> n >> m ;
   ta.resize(m) ;
   tb.resize(m) ;
   ca.resize(m) ;
   cb.resize(m) ;
   vector<pair<ll, int> > sa ;
   minf.resize(m) ;
   for (int i=0; i<m; i++) {
      minf[i] = INFTY ;
      cin >> ca[i] >> cb[i] >> ta[i] >> tb[i] ;
      sa.push_back(make_pair(tb[i], i)) ;
      if (ca[i] == 1)
         minf[i] = min(minf[i], ta[i]*ta[i]) ;
   }
   sort(sa.begin(), sa.end()) ;
   perc.resize(n+1) ;
   ll r = INFTY ;
   for (int i=0; i<sa.size(); i++) {
      int fi = sa[i].second ;
      int sc = ca[fi] ;
      ll mf = minf[fi] ;
      for (int pfi=0; pfi<perc[sc].size(); pfi++) {
         int pf = perc[sc][pfi] ;
         if (tb[pf] <= ta[fi] &&
             mf > minf[pf] + (tb[pf]-ta[fi])*(tb[pf]-ta[fi]))
            mf = minf[pf] + (tb[pf]-ta[fi])*(tb[pf]-ta[fi]) ;
      }
// cout << "Minimum frustration for flight " << fi << " is " << mf << endl ;
      minf[fi] = mf ;
      if (cb[fi] == n)
         r = min(r, mf) ;
      perc[cb[fi]].push_back(fi) ;
   }
   if (r >= INFTY)
      cout << "No route." << endl ;
   else
      cout << r << endl ;
}
