#!/usr/bin/python

import re
import sys

def read_program():
    line = sys.stdin.readline()
    print repr(line)
    num_ops = 0
    while line != 'E\n':
        num_ops += 1
        assert re.match('^(D {i}|I {i} [A-Z])\n$'.format(i='[1-9][0-9]*'), line)
        i = int(line.split()[1])
        assert 1 <= i <= 10 ** 10

        line = sys.stdin.readline()
        print repr(line)
    assert 0 <= num_ops <= 2000

read_program()
read_program()

assert sys.stdin.readline() == ''

sys.exit(42)
